unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, LCLIntf;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Memo1KeyPress(Sender: TObject; var Key: char);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  before, after, bbURLstring : string;
begin
  // Did user enter a search term?
  if Memo1.Font.Style = [fsItalic] then
    ShowMessage('You forget to enter something to search for.')
  else
  begin
    // Try to remove all leading & trailing whitesspace and replace all occurrences of a space to a +
    before := Memo1.Text;
    // #32 = space
    // #43 = +
    after  := StringReplace(Trim(before), #32, #43,
                          [rfReplaceAll, rfIgnoreCase]);
    if after = '' then
      ShowMessage('You forget to enter something to search for.')
    else
    begin
      // Build proper url with search string
      // #38 = &

      bbURLstring := ('http://bitbucket.org/'+after+'/');


      // Open url in default browser
      OpenURL (bbURLstring);
    end;
  end;
end;

procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: char);
begin
  // clear default text
  if Memo1.Font.Style = [fsItalic] then
  begin
    Memo1.Text := '';
    Memo1.Font.Color := clWindowText;
    Memo1.Font.Style := [];
  end;
 {
 // #1 = Ctrl+A
 // #3 = Ctrl+C
 // #22 = Ctrl+V
 // #24 = Ctrl+X
 }
 // #8 = Backspace
 // #13 = enter key
 // #34 = " (quote)
 // #32 = space
 // #39 = ' (apostrophe)
 // #45 = - (minus/dash)
 // #95 = _ (underscore)
 // #46 = . (period)
 // #44 = , (comma)
 // #0 = nothing
  if not (Key in [#1,#3,#8,#13,#22,#24,#34,#32,#39,#45,#95,#46,#44, '0'..'9', 'a'..'z', 'A'..'Z']) then
    begin
      //Toss out invalid key
      Key := #0;
    end;
  if Key = #13 then
    begin
      Key := #0;
      Button1.Click;
    end;
end;

procedure TForm1.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if memo1.Font.Style = [fsItalic] then
  begin
    memo1.Text := '';
    memo1.Font.Color := clWindowText;
    memo1.Font.Style := [];
  end;
end;


end.

